/* DesktopIntegration.c generated by valac 0.56.17, the Vala compiler
 * generated from DesktopIntegration.vala, do not modify */

/*
 * Copyright 2022 elementary, Inc. <https://elementary.io>
 * Copyright 2022 Corentin Noël <tintou@noel.tf>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DOCK_TYPE_DESKTOP_INTEGRATION (dock_desktop_integration_get_type ())
#define DOCK_DESKTOP_INTEGRATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DOCK_TYPE_DESKTOP_INTEGRATION, DockDesktopIntegration))
#define DOCK_IS_DESKTOP_INTEGRATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DOCK_TYPE_DESKTOP_INTEGRATION))
#define DOCK_DESKTOP_INTEGRATION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DOCK_TYPE_DESKTOP_INTEGRATION, DockDesktopIntegrationIface))

typedef struct _DockDesktopIntegration DockDesktopIntegration;
typedef struct _DockDesktopIntegrationIface DockDesktopIntegrationIface;

#define DOCK_TYPE_DESKTOP_INTEGRATION_PROXY (dock_desktop_integration_proxy_get_type ())

#define DOCK_DESKTOP_INTEGRATION_TYPE_RUNNING_APPLICATION (dock_desktop_integration_running_application_get_type ())
typedef struct _DockDesktopIntegrationRunningApplication DockDesktopIntegrationRunningApplication;

#define DOCK_DESKTOP_INTEGRATION_TYPE_WINDOW (dock_desktop_integration_window_get_type ())
typedef struct _DockDesktopIntegrationWindow DockDesktopIntegrationWindow;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
enum  {
	DOCK_DESKTOP_INTEGRATION_RUNNING_APPLICATIONS_CHANGED_SIGNAL,
	DOCK_DESKTOP_INTEGRATION_WINDOWS_CHANGED_SIGNAL,
	DOCK_DESKTOP_INTEGRATION_NUM_SIGNALS
};
static guint dock_desktop_integration_signals[DOCK_DESKTOP_INTEGRATION_NUM_SIGNALS] = {0};
typedef GDBusProxy DockDesktopIntegrationProxy;
typedef GDBusProxyClass DockDesktopIntegrationProxyClass;
typedef struct _DockDesktopIntegrationGetRunningApplicationsReadyData DockDesktopIntegrationGetRunningApplicationsReadyData;
typedef struct _DockDesktopIntegrationGetWindowsReadyData DockDesktopIntegrationGetWindowsReadyData;
typedef struct _DockDesktopIntegrationShowWindowsForReadyData DockDesktopIntegrationShowWindowsForReadyData;
typedef struct _DockDesktopIntegrationFocusWindowReadyData DockDesktopIntegrationFocusWindowReadyData;

struct _DockDesktopIntegrationRunningApplication {
	gchar* app_id;
	GHashTable* details;
};

struct _DockDesktopIntegrationWindow {
	guint64 uid;
	GHashTable* properties;
};

struct _DockDesktopIntegrationIface {
	GTypeInterface parent_iface;
	void (*get_running_applications) (DockDesktopIntegration* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	DockDesktopIntegrationRunningApplication* (*get_running_applications_finish) (DockDesktopIntegration* self, GAsyncResult* _res_, gint* result_length1, GError** error);
	void (*get_windows) (DockDesktopIntegration* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	DockDesktopIntegrationWindow* (*get_windows_finish) (DockDesktopIntegration* self, GAsyncResult* _res_, gint* result_length1, GError** error);
	void (*show_windows_for) (DockDesktopIntegration* self, const gchar* app_id, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*show_windows_for_finish) (DockDesktopIntegration* self, GAsyncResult* _res_, GError** error);
	void (*focus_window) (DockDesktopIntegration* self, guint64 uid, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*focus_window_finish) (DockDesktopIntegration* self, GAsyncResult* _res_, GError** error);
	guint (*get_version) (DockDesktopIntegration* self);
};

struct _DockDesktopIntegrationGetRunningApplicationsReadyData {
	GDBusMethodInvocation* _invocation_;
};

struct _DockDesktopIntegrationGetWindowsReadyData {
	GDBusMethodInvocation* _invocation_;
};

struct _DockDesktopIntegrationShowWindowsForReadyData {
	GDBusMethodInvocation* _invocation_;
	gchar* app_id;
};

struct _DockDesktopIntegrationFocusWindowReadyData {
	GDBusMethodInvocation* _invocation_;
	guint64 uid;
};

VALA_EXTERN GType dock_desktop_integration_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dock_desktop_integration_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
VALA_EXTERN GType dock_desktop_integration_running_application_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DockDesktopIntegrationRunningApplication* dock_desktop_integration_running_application_dup (const DockDesktopIntegrationRunningApplication* self);
VALA_EXTERN void dock_desktop_integration_running_application_free (DockDesktopIntegrationRunningApplication* self);
VALA_EXTERN void dock_desktop_integration_running_application_copy (const DockDesktopIntegrationRunningApplication* self,
                                                        DockDesktopIntegrationRunningApplication* dest);
VALA_EXTERN void dock_desktop_integration_running_application_destroy (DockDesktopIntegrationRunningApplication* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DockDesktopIntegrationRunningApplication, dock_desktop_integration_running_application_destroy)
VALA_EXTERN GType dock_desktop_integration_window_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DockDesktopIntegrationWindow* dock_desktop_integration_window_dup (const DockDesktopIntegrationWindow* self);
VALA_EXTERN void dock_desktop_integration_window_free (DockDesktopIntegrationWindow* self);
VALA_EXTERN void dock_desktop_integration_window_copy (const DockDesktopIntegrationWindow* self,
                                           DockDesktopIntegrationWindow* dest);
VALA_EXTERN void dock_desktop_integration_window_destroy (DockDesktopIntegrationWindow* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DockDesktopIntegrationWindow, dock_desktop_integration_window_destroy)
VALA_EXTERN GType dock_desktop_integration_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DockDesktopIntegration, g_object_unref)
VALA_EXTERN void dock_desktop_integration_get_running_applications (DockDesktopIntegration* self,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
VALA_EXTERN DockDesktopIntegrationRunningApplication* dock_desktop_integration_get_running_applications_finish (DockDesktopIntegration* self,
                                                                                                    GAsyncResult* _res_,
                                                                                                    gint* result_length1,
                                                                                                    GError** error);
VALA_EXTERN void dock_desktop_integration_get_windows (DockDesktopIntegration* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN DockDesktopIntegrationWindow* dock_desktop_integration_get_windows_finish (DockDesktopIntegration* self,
                                                                           GAsyncResult* _res_,
                                                                           gint* result_length1,
                                                                           GError** error);
VALA_EXTERN void dock_desktop_integration_show_windows_for (DockDesktopIntegration* self,
                                                const gchar* app_id,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN void dock_desktop_integration_show_windows_for_finish (DockDesktopIntegration* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
VALA_EXTERN void dock_desktop_integration_focus_window (DockDesktopIntegration* self,
                                            guint64 uid,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN void dock_desktop_integration_focus_window_finish (DockDesktopIntegration* self,
                                                   GAsyncResult* _res_,
                                                   GError** error);
VALA_EXTERN guint dock_desktop_integration_get_version (DockDesktopIntegration* self);
static GType dock_desktop_integration_get_type_once (void);
static void dock_desktop_integration_proxy_g_signal (GDBusProxy* proxy,
                                              const gchar* sender_name,
                                              const gchar* signal_name,
                                              GVariant* parameters);
static void _dbus_handle_dock_desktop_integration_running_applications_changed (DockDesktopIntegration* self,
                                                                         GVariant* parameters);
static void _dbus_handle_dock_desktop_integration_windows_changed (DockDesktopIntegration* self,
                                                            GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object,
                                   GAsyncResult *res,
                                   void *user_data);
static void dock_desktop_integration_proxy_get_running_applications_async (DockDesktopIntegration* self,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static DockDesktopIntegrationRunningApplication* dock_desktop_integration_proxy_get_running_applications_finish (DockDesktopIntegration* self,
                                                                                                          GAsyncResult* _res_,
                                                                                                          gint* result_length1,
                                                                                                          GError** error);
static void dock_desktop_integration_proxy_get_windows_async (DockDesktopIntegration* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static DockDesktopIntegrationWindow* dock_desktop_integration_proxy_get_windows_finish (DockDesktopIntegration* self,
                                                                                 GAsyncResult* _res_,
                                                                                 gint* result_length1,
                                                                                 GError** error);
static void dock_desktop_integration_proxy_show_windows_for_async (DockDesktopIntegration* self,
                                                            const gchar* app_id,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_);
static void dock_desktop_integration_proxy_show_windows_for_finish (DockDesktopIntegration* self,
                                                             GAsyncResult* _res_,
                                                             GError** error);
static void dock_desktop_integration_proxy_focus_window_async (DockDesktopIntegration* self,
                                                        guint64 uid,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static void dock_desktop_integration_proxy_focus_window_finish (DockDesktopIntegration* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
static guint dock_desktop_integration_dbus_proxy_get_version (DockDesktopIntegration* self);
static void dock_desktop_integration_proxy_dock_desktop_integration_interface_init (DockDesktopIntegrationIface* iface);
static void _dbus_dock_desktop_integration_get_running_applications (DockDesktopIntegration* self,
                                                              GVariant* _parameters_,
                                                              GDBusMethodInvocation* invocation);
static void _vala_DockDesktopIntegrationRunningApplication_array_free (DockDesktopIntegrationRunningApplication * array,
                                                                gssize array_length);
static void _dbus_dock_desktop_integration_get_running_applications_ready (GObject * source_object,
                                                                    GAsyncResult * _res_,
                                                                    gpointer _user_data_);
static void _dbus_dock_desktop_integration_get_windows (DockDesktopIntegration* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation);
static void _vala_DockDesktopIntegrationWindow_array_free (DockDesktopIntegrationWindow * array,
                                                    gssize array_length);
static void _dbus_dock_desktop_integration_get_windows_ready (GObject * source_object,
                                                       GAsyncResult * _res_,
                                                       gpointer _user_data_);
static void _dbus_dock_desktop_integration_show_windows_for (DockDesktopIntegration* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_dock_desktop_integration_show_windows_for_ready (GObject * source_object,
                                                            GAsyncResult * _res_,
                                                            gpointer _user_data_);
static void _dbus_dock_desktop_integration_focus_window (DockDesktopIntegration* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation);
static void _dbus_dock_desktop_integration_focus_window_ready (GObject * source_object,
                                                        GAsyncResult * _res_,
                                                        gpointer _user_data_);
static void dock_desktop_integration_dbus_interface_method_call (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* method_name,
                                                          GVariant* parameters,
                                                          GDBusMethodInvocation* invocation,
                                                          gpointer user_data);
static GVariant* dock_desktop_integration_dbus_interface_get_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GError** error,
                                                                gpointer user_data);
static GVariant* _dbus_dock_desktop_integration_get_version (DockDesktopIntegration* self);
static gboolean dock_desktop_integration_dbus_interface_set_property (GDBusConnection* connection,
                                                               const gchar* sender,
                                                               const gchar* object_path,
                                                               const gchar* interface_name,
                                                               const gchar* property_name,
                                                               GVariant* value,
                                                               GError** error,
                                                               gpointer user_data);
static void _dbus_dock_desktop_integration_running_applications_changed (GObject* _sender,
                                                                  gpointer* _data);
static void _dbus_dock_desktop_integration_windows_changed (GObject* _sender,
                                                     gpointer* _data);
static void _dock_desktop_integration_unregister_object (gpointer user_data);

static const GDBusArgInfo _dock_desktop_integration_dbus_arg_info_get_running_applications_result = {-1, "result", "a(sa{sv})", NULL};
static const GDBusArgInfo * const _dock_desktop_integration_dbus_arg_info_get_running_applications_in[] = {NULL};
static const GDBusArgInfo * const _dock_desktop_integration_dbus_arg_info_get_running_applications_out[] = {&_dock_desktop_integration_dbus_arg_info_get_running_applications_result, NULL};
static const GDBusMethodInfo _dock_desktop_integration_dbus_method_info_get_running_applications = {-1, "GetRunningApplications", (GDBusArgInfo **) (&_dock_desktop_integration_dbus_arg_info_get_running_applications_in), (GDBusArgInfo **) (&_dock_desktop_integration_dbus_arg_info_get_running_applications_out), NULL};
static const GDBusArgInfo _dock_desktop_integration_dbus_arg_info_get_windows_result = {-1, "result", "a(ta{sv})", NULL};
static const GDBusArgInfo * const _dock_desktop_integration_dbus_arg_info_get_windows_in[] = {NULL};
static const GDBusArgInfo * const _dock_desktop_integration_dbus_arg_info_get_windows_out[] = {&_dock_desktop_integration_dbus_arg_info_get_windows_result, NULL};
static const GDBusMethodInfo _dock_desktop_integration_dbus_method_info_get_windows = {-1, "GetWindows", (GDBusArgInfo **) (&_dock_desktop_integration_dbus_arg_info_get_windows_in), (GDBusArgInfo **) (&_dock_desktop_integration_dbus_arg_info_get_windows_out), NULL};
static const GDBusArgInfo _dock_desktop_integration_dbus_arg_info_show_windows_for_app_id = {-1, "app_id", "s", NULL};
static const GDBusArgInfo * const _dock_desktop_integration_dbus_arg_info_show_windows_for_in[] = {&_dock_desktop_integration_dbus_arg_info_show_windows_for_app_id, NULL};
static const GDBusArgInfo * const _dock_desktop_integration_dbus_arg_info_show_windows_for_out[] = {NULL};
static const GDBusMethodInfo _dock_desktop_integration_dbus_method_info_show_windows_for = {-1, "ShowWindowsFor", (GDBusArgInfo **) (&_dock_desktop_integration_dbus_arg_info_show_windows_for_in), (GDBusArgInfo **) (&_dock_desktop_integration_dbus_arg_info_show_windows_for_out), NULL};
static const GDBusArgInfo _dock_desktop_integration_dbus_arg_info_focus_window_uid = {-1, "uid", "t", NULL};
static const GDBusArgInfo * const _dock_desktop_integration_dbus_arg_info_focus_window_in[] = {&_dock_desktop_integration_dbus_arg_info_focus_window_uid, NULL};
static const GDBusArgInfo * const _dock_desktop_integration_dbus_arg_info_focus_window_out[] = {NULL};
static const GDBusMethodInfo _dock_desktop_integration_dbus_method_info_focus_window = {-1, "FocusWindow", (GDBusArgInfo **) (&_dock_desktop_integration_dbus_arg_info_focus_window_in), (GDBusArgInfo **) (&_dock_desktop_integration_dbus_arg_info_focus_window_out), NULL};
static const GDBusMethodInfo * const _dock_desktop_integration_dbus_method_info[] = {&_dock_desktop_integration_dbus_method_info_get_running_applications, &_dock_desktop_integration_dbus_method_info_get_windows, &_dock_desktop_integration_dbus_method_info_show_windows_for, &_dock_desktop_integration_dbus_method_info_focus_window, NULL};
static const GDBusArgInfo * const _dock_desktop_integration_dbus_arg_info_running_applications_changed[] = {NULL};
static const GDBusSignalInfo _dock_desktop_integration_dbus_signal_info_running_applications_changed = {-1, "RunningApplicationsChanged", (GDBusArgInfo **) (&_dock_desktop_integration_dbus_arg_info_running_applications_changed), NULL};
static const GDBusArgInfo * const _dock_desktop_integration_dbus_arg_info_windows_changed[] = {NULL};
static const GDBusSignalInfo _dock_desktop_integration_dbus_signal_info_windows_changed = {-1, "WindowsChanged", (GDBusArgInfo **) (&_dock_desktop_integration_dbus_arg_info_windows_changed), NULL};
static const GDBusSignalInfo * const _dock_desktop_integration_dbus_signal_info[] = {&_dock_desktop_integration_dbus_signal_info_running_applications_changed, &_dock_desktop_integration_dbus_signal_info_windows_changed, NULL};
static const GDBusPropertyInfo _dock_desktop_integration_dbus_property_info_version = {-1, "Version", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _dock_desktop_integration_dbus_property_info[] = {&_dock_desktop_integration_dbus_property_info_version, NULL};
static const GDBusInterfaceInfo _dock_desktop_integration_dbus_interface_info = {-1, "org.pantheon.gala.DesktopIntegration", (GDBusMethodInfo **) (&_dock_desktop_integration_dbus_method_info), (GDBusSignalInfo **) (&_dock_desktop_integration_dbus_signal_info), (GDBusPropertyInfo **) (&_dock_desktop_integration_dbus_property_info), NULL};
static const GDBusInterfaceVTable _dock_desktop_integration_dbus_interface_vtable = {dock_desktop_integration_dbus_interface_method_call, dock_desktop_integration_dbus_interface_get_property, dock_desktop_integration_dbus_interface_set_property};

void
dock_desktop_integration_get_running_applications (DockDesktopIntegration* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	DockDesktopIntegrationIface* _iface_;
	_iface_ = DOCK_DESKTOP_INTEGRATION_GET_INTERFACE (self);
	if (_iface_->get_running_applications) {
		_iface_->get_running_applications (self, _callback_, _user_data_);
	}
}

DockDesktopIntegrationRunningApplication*
dock_desktop_integration_get_running_applications_finish (DockDesktopIntegration* self,
                                                          GAsyncResult* _res_,
                                                          gint* result_length1,
                                                          GError** error)
{
	DockDesktopIntegrationIface* _iface_;
	_iface_ = DOCK_DESKTOP_INTEGRATION_GET_INTERFACE (self);
	if (_iface_->get_running_applications_finish) {
		return _iface_->get_running_applications_finish (self, _res_, result_length1, error);
	}
	return NULL;
}

void
dock_desktop_integration_get_windows (DockDesktopIntegration* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	DockDesktopIntegrationIface* _iface_;
	_iface_ = DOCK_DESKTOP_INTEGRATION_GET_INTERFACE (self);
	if (_iface_->get_windows) {
		_iface_->get_windows (self, _callback_, _user_data_);
	}
}

DockDesktopIntegrationWindow*
dock_desktop_integration_get_windows_finish (DockDesktopIntegration* self,
                                             GAsyncResult* _res_,
                                             gint* result_length1,
                                             GError** error)
{
	DockDesktopIntegrationIface* _iface_;
	_iface_ = DOCK_DESKTOP_INTEGRATION_GET_INTERFACE (self);
	if (_iface_->get_windows_finish) {
		return _iface_->get_windows_finish (self, _res_, result_length1, error);
	}
	return NULL;
}

void
dock_desktop_integration_show_windows_for (DockDesktopIntegration* self,
                                           const gchar* app_id,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	DockDesktopIntegrationIface* _iface_;
	_iface_ = DOCK_DESKTOP_INTEGRATION_GET_INTERFACE (self);
	if (_iface_->show_windows_for) {
		_iface_->show_windows_for (self, app_id, _callback_, _user_data_);
	}
}

void
dock_desktop_integration_show_windows_for_finish (DockDesktopIntegration* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	DockDesktopIntegrationIface* _iface_;
	_iface_ = DOCK_DESKTOP_INTEGRATION_GET_INTERFACE (self);
	if (_iface_->show_windows_for_finish) {
		_iface_->show_windows_for_finish (self, _res_, error);
	}
}

void
dock_desktop_integration_focus_window (DockDesktopIntegration* self,
                                       guint64 uid,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	DockDesktopIntegrationIface* _iface_;
	_iface_ = DOCK_DESKTOP_INTEGRATION_GET_INTERFACE (self);
	if (_iface_->focus_window) {
		_iface_->focus_window (self, uid, _callback_, _user_data_);
	}
}

void
dock_desktop_integration_focus_window_finish (DockDesktopIntegration* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	DockDesktopIntegrationIface* _iface_;
	_iface_ = DOCK_DESKTOP_INTEGRATION_GET_INTERFACE (self);
	if (_iface_->focus_window_finish) {
		_iface_->focus_window_finish (self, _res_, error);
	}
}

guint
dock_desktop_integration_get_version (DockDesktopIntegration* self)
{
	DockDesktopIntegrationIface* _iface_;
	g_return_val_if_fail (self != NULL, 0U);
	_iface_ = DOCK_DESKTOP_INTEGRATION_GET_INTERFACE (self);
	if (_iface_->get_version) {
		return _iface_->get_version (self);
	}
	return 0U;
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

void
dock_desktop_integration_running_application_copy (const DockDesktopIntegrationRunningApplication* self,
                                                   DockDesktopIntegrationRunningApplication* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	_tmp0_ = (*self).app_id;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).app_id);
	(*dest).app_id = _tmp1_;
	_tmp2_ = (*self).details;
	_tmp3_ = _g_hash_table_ref0 (_tmp2_);
	_g_hash_table_unref0 ((*dest).details);
	(*dest).details = _tmp3_;
}

void
dock_desktop_integration_running_application_destroy (DockDesktopIntegrationRunningApplication* self)
{
	_g_free0 ((*self).app_id);
	_g_hash_table_unref0 ((*self).details);
}

DockDesktopIntegrationRunningApplication*
dock_desktop_integration_running_application_dup (const DockDesktopIntegrationRunningApplication* self)
{
	DockDesktopIntegrationRunningApplication* dup;
	dup = g_new0 (DockDesktopIntegrationRunningApplication, 1);
	dock_desktop_integration_running_application_copy (self, dup);
	return dup;
}

void
dock_desktop_integration_running_application_free (DockDesktopIntegrationRunningApplication* self)
{
	dock_desktop_integration_running_application_destroy (self);
	g_free (self);
}

 G_GNUC_NO_INLINE static GType
dock_desktop_integration_running_application_get_type_once (void)
{
	GType dock_desktop_integration_running_application_type_id;
	dock_desktop_integration_running_application_type_id = g_boxed_type_register_static ("DockDesktopIntegrationRunningApplication", (GBoxedCopyFunc) dock_desktop_integration_running_application_dup, (GBoxedFreeFunc) dock_desktop_integration_running_application_free);
	return dock_desktop_integration_running_application_type_id;
}

GType
dock_desktop_integration_running_application_get_type (void)
{
	static gsize dock_desktop_integration_running_application_type_id__once = 0;
	if (g_once_init_enter (&dock_desktop_integration_running_application_type_id__once)) {
		GType dock_desktop_integration_running_application_type_id;
		dock_desktop_integration_running_application_type_id = dock_desktop_integration_running_application_get_type_once ();
		g_once_init_leave (&dock_desktop_integration_running_application_type_id__once, dock_desktop_integration_running_application_type_id);
	}
	return dock_desktop_integration_running_application_type_id__once;
}

void
dock_desktop_integration_window_copy (const DockDesktopIntegrationWindow* self,
                                      DockDesktopIntegrationWindow* dest)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	(*dest).uid = (*self).uid;
	_tmp0_ = (*self).properties;
	_tmp1_ = _g_hash_table_ref0 (_tmp0_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp1_;
}

void
dock_desktop_integration_window_destroy (DockDesktopIntegrationWindow* self)
{
	_g_hash_table_unref0 ((*self).properties);
}

DockDesktopIntegrationWindow*
dock_desktop_integration_window_dup (const DockDesktopIntegrationWindow* self)
{
	DockDesktopIntegrationWindow* dup;
	dup = g_new0 (DockDesktopIntegrationWindow, 1);
	dock_desktop_integration_window_copy (self, dup);
	return dup;
}

void
dock_desktop_integration_window_free (DockDesktopIntegrationWindow* self)
{
	dock_desktop_integration_window_destroy (self);
	g_free (self);
}

 G_GNUC_NO_INLINE static GType
dock_desktop_integration_window_get_type_once (void)
{
	GType dock_desktop_integration_window_type_id;
	dock_desktop_integration_window_type_id = g_boxed_type_register_static ("DockDesktopIntegrationWindow", (GBoxedCopyFunc) dock_desktop_integration_window_dup, (GBoxedFreeFunc) dock_desktop_integration_window_free);
	return dock_desktop_integration_window_type_id;
}

GType
dock_desktop_integration_window_get_type (void)
{
	static gsize dock_desktop_integration_window_type_id__once = 0;
	if (g_once_init_enter (&dock_desktop_integration_window_type_id__once)) {
		GType dock_desktop_integration_window_type_id;
		dock_desktop_integration_window_type_id = dock_desktop_integration_window_get_type_once ();
		g_once_init_leave (&dock_desktop_integration_window_type_id__once, dock_desktop_integration_window_type_id);
	}
	return dock_desktop_integration_window_type_id__once;
}

static void
dock_desktop_integration_default_init (DockDesktopIntegrationIface * iface,
                                       gpointer iface_data)
{
	dock_desktop_integration_signals[DOCK_DESKTOP_INTEGRATION_RUNNING_APPLICATIONS_CHANGED_SIGNAL] = g_signal_new ("running-applications-changed", DOCK_TYPE_DESKTOP_INTEGRATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	dock_desktop_integration_signals[DOCK_DESKTOP_INTEGRATION_WINDOWS_CHANGED_SIGNAL] = g_signal_new ("windows-changed", DOCK_TYPE_DESKTOP_INTEGRATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

 G_GNUC_NO_INLINE static GType
dock_desktop_integration_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DockDesktopIntegrationIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dock_desktop_integration_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dock_desktop_integration_type_id;
	dock_desktop_integration_type_id = g_type_register_static (G_TYPE_INTERFACE, "DockDesktopIntegration", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dock_desktop_integration_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (dock_desktop_integration_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) dock_desktop_integration_proxy_get_type);
	g_type_set_qdata (dock_desktop_integration_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.pantheon.gala.DesktopIntegration");
	g_type_set_qdata (dock_desktop_integration_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_dock_desktop_integration_dbus_interface_info));
	g_type_set_qdata (dock_desktop_integration_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) dock_desktop_integration_register_object);
	return dock_desktop_integration_type_id;
}

GType
dock_desktop_integration_get_type (void)
{
	static gsize dock_desktop_integration_type_id__once = 0;
	if (g_once_init_enter (&dock_desktop_integration_type_id__once)) {
		GType dock_desktop_integration_type_id;
		dock_desktop_integration_type_id = dock_desktop_integration_get_type_once ();
		g_once_init_leave (&dock_desktop_integration_type_id__once, dock_desktop_integration_type_id);
	}
	return dock_desktop_integration_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (DockDesktopIntegrationProxy, dock_desktop_integration_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (DOCK_TYPE_DESKTOP_INTEGRATION, dock_desktop_integration_proxy_dock_desktop_integration_interface_init) )
static void
dock_desktop_integration_proxy_class_init (DockDesktopIntegrationProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = dock_desktop_integration_proxy_g_signal;
}

static void
_dbus_handle_dock_desktop_integration_running_applications_changed (DockDesktopIntegration* self,
                                                                    GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "running-applications-changed");
}

static void
_dbus_handle_dock_desktop_integration_windows_changed (DockDesktopIntegration* self,
                                                       GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "windows-changed");
}

static void
dock_desktop_integration_proxy_g_signal (GDBusProxy* proxy,
                                         const gchar* sender_name,
                                         const gchar* signal_name,
                                         GVariant* parameters)
{
	if (strcmp (signal_name, "RunningApplicationsChanged") == 0) {
		_dbus_handle_dock_desktop_integration_running_applications_changed ((DockDesktopIntegration*) proxy, parameters);
	} else if (strcmp (signal_name, "WindowsChanged") == 0) {
		_dbus_handle_dock_desktop_integration_windows_changed ((DockDesktopIntegration*) proxy, parameters);
	}
}

static void
dock_desktop_integration_proxy_init (DockDesktopIntegrationProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_dock_desktop_integration_dbus_interface_info));
}

static void
_vala_g_async_ready_callback (GObject *source_object,
                              GAsyncResult *res,
                              void *user_data)
{
	g_task_return_pointer (user_data, g_object_ref (res), g_object_unref);
	g_object_unref (user_data);
}

static void
dock_desktop_integration_proxy_get_running_applications_async (DockDesktopIntegration* self,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.pantheon.gala.DesktopIntegration", "GetRunningApplications");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	if (_callback_ != NULL) {
		g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
	} else {
		g_dbus_message_set_flags (_message, G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED);
		g_dbus_connection_send_message (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	}
	g_object_unref (_message);
}

static DockDesktopIntegrationRunningApplication*
dock_desktop_integration_proxy_get_running_applications_finish (DockDesktopIntegration* self,
                                                                GAsyncResult* _res_,
                                                                gint* result_length1,
                                                                GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	DockDesktopIntegrationRunningApplication* _result = NULL;
	gint _result_length1;
	GVariant* _tmp0_;
	DockDesktopIntegrationRunningApplication* _tmp1_;
	gint _tmp1__length;
	gint _tmp1__size;
	gint _tmp1__length1;
	GVariantIter _tmp2_;
	GVariant* _tmp3_;
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
	g_object_unref (_inner_res);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp0_ = g_variant_iter_next_value (&_reply_iter);
	_tmp1_ = g_new (DockDesktopIntegrationRunningApplication, 5);
	_tmp1__length = 0;
	_tmp1__size = 4;
	_tmp1__length1 = 0;
	g_variant_iter_init (&_tmp2_, _tmp0_);
	for (; (_tmp3_ = g_variant_iter_next_value (&_tmp2_)) != NULL; _tmp1__length1++) {
		DockDesktopIntegrationRunningApplication _tmp4_;
		GVariantIter _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		GHashTable* _tmp8_;
		GVariantIter _tmp9_;
		GVariant* _tmp10_;
		GVariant* _tmp11_;
		if (_tmp1__size == _tmp1__length) {
			_tmp1__size = 2 * _tmp1__size;
			_tmp1_ = g_renew (DockDesktopIntegrationRunningApplication, _tmp1_, _tmp1__size + 1);
		}
		g_variant_iter_init (&_tmp5_, _tmp3_);
		_tmp6_ = g_variant_iter_next_value (&_tmp5_);
		_tmp4_.app_id = g_variant_dup_string (_tmp6_, NULL);
		g_variant_unref (_tmp6_);
		_tmp7_ = g_variant_iter_next_value (&_tmp5_);
		_tmp8_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp9_, _tmp7_);
		while (g_variant_iter_loop (&_tmp9_, "{?*}", &_tmp10_, &_tmp11_)) {
			g_hash_table_insert (_tmp8_, g_variant_dup_string (_tmp10_, NULL), g_variant_get_variant (_tmp11_));
		}
		_tmp4_.details = _tmp8_;
		g_variant_unref (_tmp7_);
		_tmp1_[_tmp1__length++] = _tmp4_;
		g_variant_unref (_tmp3_);
	}
	_result_length1 = _tmp1__length1;
	_result = _tmp1_;
	g_variant_unref (_tmp0_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static void
dock_desktop_integration_proxy_get_windows_async (DockDesktopIntegration* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.pantheon.gala.DesktopIntegration", "GetWindows");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	if (_callback_ != NULL) {
		g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
	} else {
		g_dbus_message_set_flags (_message, G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED);
		g_dbus_connection_send_message (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	}
	g_object_unref (_message);
}

static DockDesktopIntegrationWindow*
dock_desktop_integration_proxy_get_windows_finish (DockDesktopIntegration* self,
                                                   GAsyncResult* _res_,
                                                   gint* result_length1,
                                                   GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	DockDesktopIntegrationWindow* _result = NULL;
	gint _result_length1;
	GVariant* _tmp12_;
	DockDesktopIntegrationWindow* _tmp13_;
	gint _tmp13__length;
	gint _tmp13__size;
	gint _tmp13__length1;
	GVariantIter _tmp14_;
	GVariant* _tmp15_;
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
	g_object_unref (_inner_res);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp12_ = g_variant_iter_next_value (&_reply_iter);
	_tmp13_ = g_new (DockDesktopIntegrationWindow, 5);
	_tmp13__length = 0;
	_tmp13__size = 4;
	_tmp13__length1 = 0;
	g_variant_iter_init (&_tmp14_, _tmp12_);
	for (; (_tmp15_ = g_variant_iter_next_value (&_tmp14_)) != NULL; _tmp13__length1++) {
		DockDesktopIntegrationWindow _tmp16_;
		GVariantIter _tmp17_;
		GVariant* _tmp18_;
		GVariant* _tmp19_;
		GHashTable* _tmp20_;
		GVariantIter _tmp21_;
		GVariant* _tmp22_;
		GVariant* _tmp23_;
		if (_tmp13__size == _tmp13__length) {
			_tmp13__size = 2 * _tmp13__size;
			_tmp13_ = g_renew (DockDesktopIntegrationWindow, _tmp13_, _tmp13__size + 1);
		}
		g_variant_iter_init (&_tmp17_, _tmp15_);
		_tmp18_ = g_variant_iter_next_value (&_tmp17_);
		_tmp16_.uid = g_variant_get_uint64 (_tmp18_);
		g_variant_unref (_tmp18_);
		_tmp19_ = g_variant_iter_next_value (&_tmp17_);
		_tmp20_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp21_, _tmp19_);
		while (g_variant_iter_loop (&_tmp21_, "{?*}", &_tmp22_, &_tmp23_)) {
			g_hash_table_insert (_tmp20_, g_variant_dup_string (_tmp22_, NULL), g_variant_get_variant (_tmp23_));
		}
		_tmp16_.properties = _tmp20_;
		g_variant_unref (_tmp19_);
		_tmp13_[_tmp13__length++] = _tmp16_;
		g_variant_unref (_tmp15_);
	}
	_result_length1 = _tmp13__length1;
	_result = _tmp13_;
	g_variant_unref (_tmp12_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static void
dock_desktop_integration_proxy_show_windows_for_async (DockDesktopIntegration* self,
                                                       const gchar* app_id,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.pantheon.gala.DesktopIntegration", "ShowWindowsFor");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (app_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	if (_callback_ != NULL) {
		g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
	} else {
		g_dbus_message_set_flags (_message, G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED);
		g_dbus_connection_send_message (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	}
	g_object_unref (_message);
}

static void
dock_desktop_integration_proxy_show_windows_for_finish (DockDesktopIntegration* self,
                                                        GAsyncResult* _res_,
                                                        GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
	g_object_unref (_inner_res);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
dock_desktop_integration_proxy_focus_window_async (DockDesktopIntegration* self,
                                                   guint64 uid,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.pantheon.gala.DesktopIntegration", "FocusWindow");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint64 (uid));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	if (_callback_ != NULL) {
		g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
	} else {
		g_dbus_message_set_flags (_message, G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED);
		g_dbus_connection_send_message (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	}
	g_object_unref (_message);
}

static void
dock_desktop_integration_proxy_focus_window_finish (DockDesktopIntegration* self,
                                                    GAsyncResult* _res_,
                                                    GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
	g_object_unref (_inner_res);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static guint
dock_desktop_integration_dbus_proxy_get_version (DockDesktopIntegration* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Version");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.pantheon.gala.DesktopIntegration"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Version"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp24_ = 0U;
			return _tmp24_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
dock_desktop_integration_proxy_dock_desktop_integration_interface_init (DockDesktopIntegrationIface* iface)
{
	iface->get_running_applications = dock_desktop_integration_proxy_get_running_applications_async;
	iface->get_running_applications_finish = dock_desktop_integration_proxy_get_running_applications_finish;
	iface->get_windows = dock_desktop_integration_proxy_get_windows_async;
	iface->get_windows_finish = dock_desktop_integration_proxy_get_windows_finish;
	iface->show_windows_for = dock_desktop_integration_proxy_show_windows_for_async;
	iface->show_windows_for_finish = dock_desktop_integration_proxy_show_windows_for_finish;
	iface->focus_window = dock_desktop_integration_proxy_focus_window_async;
	iface->focus_window_finish = dock_desktop_integration_proxy_focus_window_finish;
	iface->get_version = dock_desktop_integration_dbus_proxy_get_version;
}

static void
_dbus_dock_desktop_integration_get_running_applications (DockDesktopIntegration* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	DockDesktopIntegrationGetRunningApplicationsReadyData* _ready_data;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (DockDesktopIntegrationGetRunningApplicationsReadyData);
	_ready_data->_invocation_ = invocation;
	dock_desktop_integration_get_running_applications (self, (GAsyncReadyCallback) _dbus_dock_desktop_integration_get_running_applications_ready, _ready_data);
}

static void
_vala_DockDesktopIntegrationRunningApplication_array_free (DockDesktopIntegrationRunningApplication * array,
                                                           gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			dock_desktop_integration_running_application_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_dock_desktop_integration_get_running_applications_ready (GObject * source_object,
                                                               GAsyncResult * _res_,
                                                               gpointer _user_data_)
{
	DockDesktopIntegrationGetRunningApplicationsReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	DockDesktopIntegrationRunningApplication* result;
	gint result_length1 = 0;
	DockDesktopIntegrationRunningApplication* _tmp25_;
	GVariantBuilder _tmp26_;
	gint _tmp27_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	result = dock_desktop_integration_get_running_applications_finish ((DockDesktopIntegration*) source_object, _res_, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp25_ = result;
	g_variant_builder_init (&_tmp26_, G_VARIANT_TYPE ("a(sa{sv})"));
	for (_tmp27_ = 0; _tmp27_ < result_length1; _tmp27_++) {
		GVariantBuilder _tmp28_;
		GVariantBuilder _tmp29_;
		GHashTableIter _tmp30_;
		gpointer _tmp31_;
		gpointer _tmp32_;
		g_variant_builder_init (&_tmp28_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp28_, g_variant_new_string ((*_tmp25_).app_id));
		g_hash_table_iter_init (&_tmp30_, (*_tmp25_).details);
		g_variant_builder_init (&_tmp29_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp30_, &_tmp31_, &_tmp32_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp31_;
			_value = (GVariant*) _tmp32_;
			g_variant_builder_add (&_tmp29_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp28_, g_variant_builder_end (&_tmp29_));
		g_variant_builder_add_value (&_tmp26_, g_variant_builder_end (&_tmp28_));
		_tmp25_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp26_));
	result = (_vala_DockDesktopIntegrationRunningApplication_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	g_slice_free (DockDesktopIntegrationGetRunningApplicationsReadyData, _ready_data);
}

static void
_dbus_dock_desktop_integration_get_windows (DockDesktopIntegration* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	DockDesktopIntegrationGetWindowsReadyData* _ready_data;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (DockDesktopIntegrationGetWindowsReadyData);
	_ready_data->_invocation_ = invocation;
	dock_desktop_integration_get_windows (self, (GAsyncReadyCallback) _dbus_dock_desktop_integration_get_windows_ready, _ready_data);
}

static void
_vala_DockDesktopIntegrationWindow_array_free (DockDesktopIntegrationWindow * array,
                                               gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			dock_desktop_integration_window_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_dock_desktop_integration_get_windows_ready (GObject * source_object,
                                                  GAsyncResult * _res_,
                                                  gpointer _user_data_)
{
	DockDesktopIntegrationGetWindowsReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	DockDesktopIntegrationWindow* result;
	gint result_length1 = 0;
	DockDesktopIntegrationWindow* _tmp33_;
	GVariantBuilder _tmp34_;
	gint _tmp35_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	result = dock_desktop_integration_get_windows_finish ((DockDesktopIntegration*) source_object, _res_, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp33_ = result;
	g_variant_builder_init (&_tmp34_, G_VARIANT_TYPE ("a(ta{sv})"));
	for (_tmp35_ = 0; _tmp35_ < result_length1; _tmp35_++) {
		GVariantBuilder _tmp36_;
		GVariantBuilder _tmp37_;
		GHashTableIter _tmp38_;
		gpointer _tmp39_;
		gpointer _tmp40_;
		g_variant_builder_init (&_tmp36_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp36_, g_variant_new_uint64 ((*_tmp33_).uid));
		g_hash_table_iter_init (&_tmp38_, (*_tmp33_).properties);
		g_variant_builder_init (&_tmp37_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp38_, &_tmp39_, &_tmp40_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp39_;
			_value = (GVariant*) _tmp40_;
			g_variant_builder_add (&_tmp37_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp36_, g_variant_builder_end (&_tmp37_));
		g_variant_builder_add_value (&_tmp34_, g_variant_builder_end (&_tmp36_));
		_tmp33_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp34_));
	result = (_vala_DockDesktopIntegrationWindow_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	g_slice_free (DockDesktopIntegrationGetWindowsReadyData, _ready_data);
}

static void
_dbus_dock_desktop_integration_show_windows_for (DockDesktopIntegration* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	DockDesktopIntegrationShowWindowsForReadyData* _ready_data;
	GVariant* _tmp41_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (DockDesktopIntegrationShowWindowsForReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp41_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->app_id = g_variant_dup_string (_tmp41_, NULL);
	g_variant_unref (_tmp41_);
	dock_desktop_integration_show_windows_for (self, _ready_data->app_id, (GAsyncReadyCallback) _dbus_dock_desktop_integration_show_windows_for_ready, _ready_data);
	_error:
	;
}

static void
_dbus_dock_desktop_integration_show_windows_for_ready (GObject * source_object,
                                                       GAsyncResult * _res_,
                                                       gpointer _user_data_)
{
	DockDesktopIntegrationShowWindowsForReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	dock_desktop_integration_show_windows_for_finish ((DockDesktopIntegration*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (_ready_data->app_id);
	g_slice_free (DockDesktopIntegrationShowWindowsForReadyData, _ready_data);
}

static void
_dbus_dock_desktop_integration_focus_window (DockDesktopIntegration* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	DockDesktopIntegrationFocusWindowReadyData* _ready_data;
	GVariant* _tmp42_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (DockDesktopIntegrationFocusWindowReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp42_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->uid = g_variant_get_uint64 (_tmp42_);
	g_variant_unref (_tmp42_);
	dock_desktop_integration_focus_window (self, _ready_data->uid, (GAsyncReadyCallback) _dbus_dock_desktop_integration_focus_window_ready, _ready_data);
}

static void
_dbus_dock_desktop_integration_focus_window_ready (GObject * source_object,
                                                   GAsyncResult * _res_,
                                                   gpointer _user_data_)
{
	DockDesktopIntegrationFocusWindowReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	dock_desktop_integration_focus_window_finish ((DockDesktopIntegration*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	g_slice_free (DockDesktopIntegrationFocusWindowReadyData, _ready_data);
}

static void
dock_desktop_integration_dbus_interface_method_call (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* method_name,
                                                     GVariant* parameters,
                                                     GDBusMethodInvocation* invocation,
                                                     gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetRunningApplications") == 0) {
		_dbus_dock_desktop_integration_get_running_applications (object, parameters, invocation);
	} else if (strcmp (method_name, "GetWindows") == 0) {
		_dbus_dock_desktop_integration_get_windows (object, parameters, invocation);
	} else if (strcmp (method_name, "ShowWindowsFor") == 0) {
		_dbus_dock_desktop_integration_show_windows_for (object, parameters, invocation);
	} else if (strcmp (method_name, "FocusWindow") == 0) {
		_dbus_dock_desktop_integration_focus_window (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_dock_desktop_integration_get_version (DockDesktopIntegration* self)
{
	guint result;
	GVariant* _reply;
	result = dock_desktop_integration_get_version (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
dock_desktop_integration_dbus_interface_get_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GError** error,
                                                      gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Version") == 0) {
		return _dbus_dock_desktop_integration_get_version (object);
	}
	return NULL;
}

static gboolean
dock_desktop_integration_dbus_interface_set_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GVariant* value,
                                                      GError** error,
                                                      gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_dock_desktop_integration_running_applications_changed (GObject* _sender,
                                                             gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.pantheon.gala.DesktopIntegration", "RunningApplicationsChanged", _arguments, NULL);
}

static void
_dbus_dock_desktop_integration_windows_changed (GObject* _sender,
                                                gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.pantheon.gala.DesktopIntegration", "WindowsChanged", _arguments, NULL);
}

guint
dock_desktop_integration_register_object (gpointer object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_dock_desktop_integration_dbus_interface_info), &_dock_desktop_integration_dbus_interface_vtable, data, _dock_desktop_integration_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "running-applications-changed", (GCallback) _dbus_dock_desktop_integration_running_applications_changed, data);
	g_signal_connect (object, "windows-changed", (GCallback) _dbus_dock_desktop_integration_windows_changed, data);
	return result;
}

static void
_dock_desktop_integration_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dock_desktop_integration_running_applications_changed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dock_desktop_integration_windows_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

